

#ifndef LINUX
#define LINUX
#endif
#ifndef _LARGEFILE_SOURCE 
#define _LARGEFILE_SOURCE
#endif 
#define _LARGEFILE64_SOURCE
#define SENDOPTIONS MSG_NOSIGNAL
// #endif

extern "C"{
  //#include <getopt.h>
}
#include "k5vsi_mdl.hpp"

#define DEBUG(x) 

char *me;  // My name

void usage(){
  printf("Usage: %s [options]\n",me);
  printf("  -s <Byte>    :      UDP block size\n");
  printf("  -t <xs|xm|xh>:      time length to sent\n");
  printf("  -p <PORT>    :      Port to use\n");
  printf("  -a <HOSTNAME>:      Remote host name\n");
  printf("  -m <'xxMsps/xbit/xxch'>: Data mode\n");
  printf("        Msps -> [04Msps|08Msps|16Msps|32Msps|64Msps]\n");
  printf("        bit  -> 2bit only                       \n");
  printf("        ch   -> [16ch|08ch|04ch]                \n");
  printf("  -f <filename>: Writing to file. \n");
  printf("  -g <igrp>    : Group number 0-32/nch, default(0).\n");
  printf("  -h                    This list\n");
  exit(1);
}

int main (int argc, char * const argv[]) {
  me = (me = strrchr(argv[0], '/')) == NULL ? argv[0] : me+1; /* My name */ 
  
  int tmp, sock, i;
  //  ssize_t nwrote;
  string  msg;
  
  K5_VSI_SENDER k5vsi;
  k5vsi.Set_Port( DEF_M5DAT_PORT );
  k5vsi.Set_Mode("16Msps/2bit/08ch");
  string fname;
  int work;
  int mtu  = DEFAULT_MTU;
  if(argc < 2) usage();
  
  int k=0;
  while (k >= 0) { 
    switch (k = getopt(argc, argv, "hs:t:p:a:m:f:g:")) { 
    case 'h':   usage();     break;
    case 'p':    k5vsi.Set_Port( atoi(optarg) );break;
    case 'a':   k5vsi.Set_Host(optarg);      break;
    case 't':   k5vsi.Set_Length(optarg); break;
    case 'g':   
      work=atoi(optarg); 
      k5vsi.Set_iGrp(work); break;
    case 'm':   
      if( k5vsi.Set_Mode(optarg) >0) 
	fprintf(stderr,"Mode=%s\n",optarg); 
      break;
    case 'f':   fname =optarg; k5vsi.Set_outfile(fname.c_str()); break;
    case 's':   mtu = atoi(optarg); k5vsi.Set_mtu(mtu); break;
    case '?':    usage(); break;
    }
  }
  
  // Network setup 
  k5vsi.Sock_Create();
  if(k5vsi.Setup_Net()) exit(1);
 
  k5vsi.Init_Buf(); // Initialization of packet buffer

  
  if(k5vsi.DevOpen() <0){ // vsi/mem device open 
    cerr << " Stop due to error\n";
    exit(1);
  }
  
  if(k5vsi.Send_Mk5() < 0){
    cerr << "Error: in k5vsi.Send_Mk5() \n";
    return -1;
  }

  k5vsi.Close_Net();

  return(0);
}
  

// int setup_net(char *hostname, unsigned short port, int *sock) {
//   int status;
//   unsigned long ip_addr;
//   struct hostent     *hostptr;
//   struct sockaddr_in server; 

//   /* Initialise server's address */
//   memset((char *)&server,0,sizeof(server));
//   server.sin_family = AF_INET;
//   server.sin_port = htons(port); /* Which port number to use */

//   /* Create socket */
//   *sock = socket(AF_INET,SOCK_DGRAM, IPPROTO_UDP); 
//   if (*sock==-1) {
//     perror("Error creating socket");
//     return(1);
//   }

//   /* Look up hostname */
//   hostptr = gethostbyname(hostname);
//   if (hostptr==NULL) {
//     fprintf(stderr,"Failed to look up hostname %s\n", hostname);
//     return(1);
//   }
//   memcpy(&ip_addr, (char *)hostptr->h_addr, sizeof(ip_addr));

//   printf("IP ADDR = %lu for %s\n", ip_addr, hostname);
//   server.sin_addr.s_addr = ip_addr;

//   status = connect(*sock, (struct sockaddr *) &server, sizeof(server));
//   if (status!=0) {
//     perror("Failed to connect to server");
//     return(1);
//   }

//   return(0);
// }


// double tim(void) {
//   struct timeval tv;
//   double t;

//   gettimeofday(&tv, NULL);
//   t = (double)tv.tv_sec + (double)tv.tv_usec/1000000.0;

//   return t;
// }
  
// void my_usleep(u_int64_t usec) {
//   double now, till;
//   int n;
//   /* The current time */
//   now = tim();

//   /* The time we are sleeping till */
//   till = now+usec/1.0e6;

//   /* and spin for the rest of the time */
//   n = 0;
//   while (now<till) {
//     now = tim();
//     n++;
//   }
  
// }

