
#include "InDev_mdl.hpp"


const bool InDev_Model::Ready(){
  cerr << "Opening Input data/device file...";
  inputState = READY;
  if( OpenDev() < 0 ){
    cerr << "E InDev_Model::Ready(): failed to open Input device/file \n";
    //    cerr << "   InputFile_Model thread closing\n";  
    return false;
  } 
  if(vlbi_frame ==0){
    cerr << "E InDev_Model::Ready(): vlbi_frame is not set" << endl;
    Logsystem::error_logger()->Tstamp() 
      << "E InDev_Model::Ready(): vlbi_frame is not set\n";
    return false;
  }
//   if(vlbi_frame->Check() < 0){
//     cerr << "Error in InDev_Model::Ready(): vlbi_frame->Check() failed." 
// 	 << endl;
//     Logsystem::error_logger()->Tstamp() 
//       << "Error in InDev_Model::Ready(): vlbi_frame->Check() failed."
//       << endl;
//     return false;
//   }

  cerr << "InDev_Model::Ready().\n";
  Logsystem::info_logger()->Tstamp() << "InDev_Model::" << DevType()
				     << " Opened and Ready\n";
  
  InitPage();
  return true;
}

int InDev_Model::Set_DasInfo(const DAS_Info& inf){
  if(vlbi_frame ==0){
    Logsystem::error_logger()->Tstamp()
      << "Error @InDev_Model::Set_DasInfo(): vlbi_frame is empty\n";
    return -2;
  }
  vlbi_frame->Set_DasInfo(inf); 
  return 1;
}

const DAS_Info* InDev_Model::Das_inf() const{
  if(vlbi_frame ==0){
    Logsystem::error_logger()->Tstamp()
      << "Error @InDev_Model::Das_inf(): vlbi_frame is empty.\n";
    return 0;
    //    DAS_Info das(0,-1,-1); return das;
  }
  return &(vlbi_frame->DAS_Inf());
}

VLBI_Frame::VLBI_Frame_t InDev_Model::VlbiFrameType()const {
  if(vlbi_frame ==0){
    Logsystem::error_logger()->Tstamp()
      << "Error @InDev_Model::Das_inf(): vlbi_frame is empty.\n";
    return VLBI_Frame::Undef_frm;
  }
  return vlbi_frame->Type();
}


int32_t InDev_Model::Framesize()const { 
  if(vlbi_frame ==0){
    Logsystem::error_logger()->Tstamp()
      << "Error @InDev_Model::Das_inf(): vlbi_frame is empty.\n";
    return -1;
  }
  return vlbi_frame->Framesize();
}
