
#include "InNet_mdl.hpp"


void* InNet_Model::thread_func(){
    cerr << "Input Net opened.\n";
    if( rcv_proto->ProtocolState() == TransInfo::RX_READY){
      ReceivingData();  
    }else{
	Logsystem::error_logger()->Tstamp() 
	    << "E @InNet_Model::thread_func(): Recv protocol state is not rx_ready. "
	    << "Rx_Ready() must be first.\n";
    }
    InNet_Model::Stop();
    //    CloseDev();
    //    StopState();
//  Thread::state = Thread::ENDING;
    cerr << " Leaving InNet_mdl-thread..." << endl;
    
    //  Ready(); // For next calling 
    
    return 0;
}

const int InNet_Model::OpenDev(){

  if( rcv_proto == 0 ){
    cerr <<  "E InNet_Model::OpenDev(): Receivind Protocol is not ready." << endl;
    return -1;
  }
  if( Status() == Thread::RUNNING ) return 0;
  
  int dport = rcv_proto->DataPort();
  if( rcv_proto->Rx_Ready(dport) ){
      cerr << " InNet_Model rx_procotol is Ready\n";
  }else{
      cerr << "E InNet_Model::OpenDev(): Rx_Ready() failed." << endl;   
      return -1;
  }
  
  return 0;
}


int InNet_Model::ReceivingData(){
  Logsystem::info_logger()->Tstamp() << "DataReceiving start.\n";
  if( rcv_proto == 0){
    cerr << "Error in InNet_Model::ReceivingData(): Receivind Protocol is not ready."
	 << endl;
    return -1;
  }
  
  //  rcv_proto->Timer_Start();
  cerr << "InNet_Model::ReceivingData() Timer started." << endl;
  Logsystem::info_logger()->Tstamp() 
    << "InNet_Model::ReceivingData() Timer started.\n";

  int ret = rcv_proto->RXvdif(dpage);
  
  if( ret < 0){
    cerr << "E InNet_Model::ReceivingData(): Error returned from RX()"
	 << endl;
    Logsystem::error_logger()->Tstamp() 
      << "E InNet_Model::ReceivingData(): Error returned from RX().\n";
  }
 
  cerr << "I InNet_Model::ReceivingData(): End." << endl;
  Logsystem::error_logger()->Tstamp() 
    << "I InNet_Model::ReceivingData(): End.\n";
  return ret;
}



// const InNet_Model::IndevReturns_t 
// InNet_Model::MappingData(vector <uint8_t>& pntr, const time_t epoch){
  
//   //  dpage.PrintPageState();
//   int ipage = epoch % dpage.npage;
//   if(dpage.status[ipage] == DataPage::DATA_END){
//     cerr << "InFile_Model::MappingData(): END Found.\n";
//     return DATA_END;
//   }
//   //  cerr << "Mapping " << ipage << ": ";    dpage.PrintPageState();
//   time_t t1 = dpage.Epoch(ipage);
//   int nloop = N_LOOP_LIMIT;
//   bool tcond = t1 < epoch;
//   while( tcond && nloop > 0){
// //   while( (dpage.status[ipage] == DataPage::WR_OK ||
// // 	  dpage.status[ipage] == DataPage::RD_OK) &&
// // 	 t1 != epoch && nloop > 0 ){ 
//     Logsystem::debug_logger()->Tstamp() 
//       << "Waiting(" << nloop << ") for Reading..Page[" << ipage << "]"
//       <<  dpage.StrPageState() << endl ;
//     Logsystem::debug_logger()->Flush();
//     //    cerr << "Waiting(" << nloop << ") for Reading..Page[" 
//     //	 << ipage << "]" <<  dpage.StrPageState() << endl ;
//     struct timeval now;
//     struct timespec timeout;
//     gettimeofday(&now,0);
//     timeout.tv_sec = now.tv_sec + 1;
//     timeout.tv_nsec = now.tv_usec * 1000;
//     mutex_page.cond_timewait(&timeout);
//     t1 = dpage.Epoch(ipage);
//     tcond = t1 < epoch;
//     nloop --;
//   }
//   if( nloop == 0 ){
//     char buf[2][256];
//     struct tm tm1, tm2;
//     gmtime_r(&epoch, &tm1);
//     gmtime_r(&t1, &tm2);
//     strftime(buf[0],256,"%Y/%j-%H:%M:%S",&tm1);
//     strftime(buf[1],256,"%Y/%j-%H:%M:%S",&tm2);
//     Logsystem::error_logger()->Tstamp() 
//       << "Error at InNet_Model::Mapping(): Failed to get expected time." 
//       << "Data(" << buf[0] << ") but (" << buf[1] << ")" << endl;
//     return GEN_ERROR;
//   }
  
//   if(t1 != epoch ){
//     char buf[2][256];
//     struct tm tm1, tm2;
//     gmtime_r(&epoch, &tm1);
//     gmtime_r(&t1, &tm2);
//     strftime(buf[0],256,"%Y/%j-%H:%M:%S",&tm1);
//     strftime(buf[1],256,"%Y/%j-%H:%M:%S",&tm2);
//     cerr << "Warining in InNet_Model::MappingData(): Time of page("<< buf[1]
// 	 << ") != requested(" << buf[0] << ")"  << endl;
//   }
//   pntr = dpage.dat[ipage];
//   return NORMAL;

// }


/// Mapping buffer address and Returns pointer address
const uint8_t* InNet_Model::MappingData(time_t epoch){
  string func_id = "InNet_Mode::MappingData():";

  //  dpage.PrintPageState();
  int ipage = epoch % dpage.Npage();
  if( dpage.TestPage(ipage, DataPage::DATA_END) ){
    cerr << "I " << func_id << " END Found.\n";
      return 0;
  }
  Logsystem::debug_logger()->Tstamp()
    << "D " << func_id << "MappingData (" << epoch 
    << ") for Reading..Page[" << ipage << "] state=" 
    <<  dpage.StrPageState() << "\n" ;
  //  cerr << "Mapping " << ipage << ": ";    dpage.PrintPageState();
  time_t t1 = dpage.Epoch(ipage);
  int nloop = N_LOOP_LIMIT;
  bool tcond = t1 < epoch;
  while( (tcond && nloop > 0) ||
	 dpage.TestPage(ipage, DataPage::R_PROTECTED)){
    if(dpage.TestPage(ipage, DataPage::DATA_END) ){
      cerr << "I " << func_id << " END Found.\n";
      return 0;
    }
//   while( (dpage.status[ipage] == DataPage::WR_OK ||
// 	  dpage.status[ipage] == DataPage::RD_OK) &&
// 	 t1 != epoch && nloop > 0 ){ 
    Logsystem::debug_logger()->Tstamp() 
      << "D " << func_id << "Waiting(" << epoch << ")"<< nloop 
      << ") for Reading..Page[" << ipage << "](" << t1 << ")"
      <<  dpage.StrPageState() << "\n" ;
    Logsystem::debug_logger()->Flush();
    cerr << "Waiting(" << nloop << ") for Reading..Page[" 
    	 << ipage << "]" <<  dpage.StrPageState() << endl ;
//     struct timeval now;
//     struct timespec timeout;
//     gettimeofday(&now,0);
//     timeout.tv_sec = now.tv_sec + 1;
//     timeout.tv_nsec = now.tv_usec * 1000;
//     mutex_page.cond_timewait(&timeout);
    usleep(1000000);
    t1 = dpage.Epoch(ipage);
    tcond = t1 < epoch;
    nloop --;
  }

  if( nloop == 0 ){
    char buf[2][256];
    struct tm tm1, tm2;
    gmtime_r(&epoch, &tm1);
    gmtime_r(&t1, &tm2);
    strftime(buf[0],256,"%Y/%j-%H:%M:%S",&tm1);
    strftime(buf[1],256,"%Y/%j-%H:%M:%S",&tm2);
    Logsystem::error_logger()->Tstamp() 
      << "E " << func_id << "Failed to get expected time." 
      << "Data(" << buf[0] << ") but (" << buf[1] << ")\n";
    return 0;
  }
  
  if(t1 != epoch ){
    char buf[2][256];
    struct tm tm1, tm2;
    gmtime_r(&epoch, &tm1);
    gmtime_r(&t1, &tm2);
    strftime(buf[0],256,"%Y/%j-%H:%M:%S",&tm1);
    strftime(buf[1],256,"%Y/%j-%H:%M:%S",&tm2);
    cerr << "W " << func_id << "timeout in loop, Time of page("
	 << buf[1] << ") != requested(" << buf[0] << ")" << endl;
  }
  //  pntr = dpage.dat[ipage];
  //  return &(dpage.dat[ipage][0]);
  return dpage.Data(ipage);

}


const InNet_Model::IndevReturns_t  InNet_Model::UnMapping(const time_t data_epoch){
  int ipage = data_epoch % dpage.Npage();
  time_t t1 = dpage.Epoch(ipage);
  IndevReturns_t ret =NORMAL;
  if( t1 != data_epoch ){
    char buf[2][256];
    struct tm tm1, tm2;
    gmtime_r( &data_epoch, &tm1 );
    gmtime_r( &t1, &tm2 );
    strftime( buf[0],256, "%Y/%j-%H:%M:%S", &tm1 );
    strftime( buf[1],256, "%Y/%j-%H:%M:%S", &tm2 );
    fprintf(stderr, "Warining in InNet_Model::UnMapping: data epoch at page(%d) from %s to %s \n",
	    ipage, buf[0],buf[1]);
    ret = GEN_WARNING;
  }
  //  cerr << "UnMapping before" << ipage << ": ";    dpage.PrintPageState();
  dpage.ChgPageState(ipage, DataPage::WR_OK);
  //  cerr << ".....After: ";    dpage.PrintPageState();
  //  mutex_page.cond_signal();
  return ret;
}

int InNet_Model::InitPage(){
  if(rcv_proto ==0 || rcv_proto->pVLBI_Frame() ==0){
    cerr << "Error in void InNet_Model::InitPage(): rcv_protocol/vlbi_frame "
	 << "is empty." << endl;
    return -1;
  }
  DAS_Info dasinfo =  vlbi_frame->DAS_Inf();
  uint32_t pagesize = dasinfo.Speed()*4;
  dpage.PageResize(pagesize);
  dpage.InitPages();
  return 0;
}


int InNet_Model::Set_protocol(VLBI_Proto* pr){
  rcv_proto = pr;
  if(pr->pVLBI_Frame() == 0){
    Logsystem::error_logger()->Tstamp() 
      << "Error in InNet_Model::Set_protocol(): vlbi_frame is not set in rcv_protocol.\n";
    return -1;
  }
//   if(pr->pVLBI_Frame()->DAS_Inf() == 0){
//     Logsystem::error_logger()->Tstamp() 
//       << "Error in InNet_Model::Set_protocol(): das_inf is not set in vlbi_frame."
//       << endl;
//     return -1;
//   }  

  const DAS_Info &das = pr->pVLBI_Frame()->DAS_Inf();
  int32_t pagesize = das.Speed()*4;  // word/sec -> Byte/sec
  if( (int32_t)dpage.Pagesize() != pagesize ){
    dpage.PageResize(pagesize); 
  }
  
  return 0;
}


const bool InNet_Model::Ready(){
    if( !InDev_Model::Ready() ){
	cerr << "Error @InNet_Model::Ready(): Failed in InDev_Model()" << endl;
	return false;
    }
    if(rcv_proto ==0){
	cerr << "Error @InNet_Model:: recv_protocol is empty." << endl;
	return false;
    }
    return true;
}

void InNet_Model::PageEnd(){
  dpage.PageEnd();
  //fill(dpage.status.begin(), dpage.status.end(),DataPage::DATA_END);
}
